package com.ims.eval.service.impl;

import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ims.common.utils.StringUtils;
import com.ims.eval.dao.EvaluationDeptBusinessContentMapper;
import com.ims.eval.entity.EvaluationDeptBusinessContent;
import com.ims.eval.entity.OrganizationStructure;
import com.ims.eval.service.IEvaluationDeptBusinessContentService;
import com.ims.eval.service.IOrganizationStructureService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * @author hlf
 * @date 2023/5/6 10:40
 * 文件说明：
 */
@Service
public class EvaluationDeptBusinessContentServiceImpl extends ServiceImpl<EvaluationDeptBusinessContentMapper, EvaluationDeptBusinessContent> implements IEvaluationDeptBusinessContentService {

	@Autowired
	private IOrganizationStructureService organizationStructureService;

	@Override
	public List<EvaluationDeptBusinessContent> detailsList(String businessPlanId, String deptId) {
		if ("23031009".equals(deptId)) {//组织人事部
			deptId = "";
		}
		return baseMapper.detailsList(businessPlanId, deptId);
	}

	@Override
	public boolean removeByBusinessPlanId(String businessPlanId) {
		return baseMapper.removeByBusinessPlanId(businessPlanId);
	}

	@Override
	public boolean saveOrUpdateBatch(List<EvaluationDeptBusinessContent> evaluationDeptBusinessContentList) {
		boolean b = false;
		List<EvaluationDeptBusinessContent> list1 = new ArrayList<>();
		List<EvaluationDeptBusinessContent> list2 = new ArrayList<>();
		for (EvaluationDeptBusinessContent evaluationDeptBusinessContent : evaluationDeptBusinessContentList) {
			if (evaluationDeptBusinessContent.getId() == null || "".equals(evaluationDeptBusinessContent.getId())) {//新增
				QueryWrapper<EvaluationDeptBusinessContent> qw = new QueryWrapper<>();
				if (StringUtils.isNotEmpty(evaluationDeptBusinessContent.getBusinessPlanId())) {
					qw.lambda().like(EvaluationDeptBusinessContent::getBusinessPlanId, evaluationDeptBusinessContent.getBusinessPlanId());
				}
				if (StringUtils.isNotEmpty(evaluationDeptBusinessContent.getTargetName())) {
					qw.lambda().like(EvaluationDeptBusinessContent::getTargetName, evaluationDeptBusinessContent.getTargetName());
				}
				List<EvaluationDeptBusinessContent> objList1 = super.list(qw);
				if (objList1.size() == 0) {
					List<OrganizationStructure> organizationStructureList = organizationStructureService.getTree("23031001", 1, "140");
					OrganizationStructure organizationStructure = organizationStructureList.get(0).getChildren().stream().filter(item -> item.getId().equals(evaluationDeptBusinessContent.getDeptId())).findFirst().orElse(null);
					if (null != organizationStructure) {
						evaluationDeptBusinessContent.setDeptName(organizationStructure.getName());
						evaluationDeptBusinessContent.setCreateTime(DateUtil.date());
						list1.add(evaluationDeptBusinessContent);
					}
				} else {
					b = false;
				}
			} else {//修改
				evaluationDeptBusinessContent.setCreateDept(null);
				QueryWrapper<EvaluationDeptBusinessContent> qw = new QueryWrapper<>();
				if (StringUtils.isNotEmpty(evaluationDeptBusinessContent.getId())) {
					qw.lambda().like(EvaluationDeptBusinessContent::getId, evaluationDeptBusinessContent.getId());
				}
				if (StringUtils.isNotEmpty(evaluationDeptBusinessContent.getBusinessPlanId())) {
					qw.lambda().like(EvaluationDeptBusinessContent::getBusinessPlanId, evaluationDeptBusinessContent.getBusinessPlanId());
				}
				if (StringUtils.isNotEmpty(evaluationDeptBusinessContent.getTargetName())) {
					qw.lambda().like(EvaluationDeptBusinessContent::getTargetName, evaluationDeptBusinessContent.getTargetName());
				}
				List<EvaluationDeptBusinessContent> objList2 = super.list(qw);
				if (objList2.size() == 1) {
					list2.add(evaluationDeptBusinessContent);
				} else if (objList2.size() == 0) {
					QueryWrapper<EvaluationDeptBusinessContent> qw1 = new QueryWrapper<>();
					if (StringUtils.isNotEmpty(evaluationDeptBusinessContent.getBusinessPlanId())) {
						qw1.lambda().like(EvaluationDeptBusinessContent::getBusinessPlanId, evaluationDeptBusinessContent.getBusinessPlanId());
					}
					if (StringUtils.isNotEmpty(evaluationDeptBusinessContent.getTargetName())) {
						qw.lambda().like(EvaluationDeptBusinessContent::getTargetName, evaluationDeptBusinessContent.getTargetName());
					}
					List<EvaluationDeptBusinessContent> objList3 = super.list(qw1);
					if (objList3.size() == 0) {
						list2.add(evaluationDeptBusinessContent);
					} else {
						b = false;
					}
				}
			}
			/*if (StringUtils.isEmpty(evaluationDeptBusinessContent.getId())) {
				List<OrganizationStructure> organizationStructureList = organizationStructureService.getTree("23031001", 1, "140");
				OrganizationStructure organizationStructure = organizationStructureList.get(0).getChildren().stream().filter(item -> item.getId().equals(evaluationDeptBusinessContent.getDeptId())).findFirst().orElse(null);
				if (null != organizationStructure) {
					evaluationDeptBusinessContent.setDeptName(organizationStructure.getName());
					evaluationDeptBusinessContent.setCreateTime(DateUtil.date());
					b = super.save(evaluationDeptBusinessContent);
				}
			} else {
				b = super.updateById(evaluationDeptBusinessContent);
			}*/
		}
		if (b) {
			if (list1.size() > 0) {
				super.saveBatch(list1);
			}
			if (list2.size() > 0) {
				super.updateBatchById(list2);
			}
		}
		return b;
	}

	@Override
	public List<EvaluationDeptBusinessContent> selectEvaluationDeptBusinessContentListByBusinessPlanId(String businessPlanId, String deptId) {
		return baseMapper.selectEvaluationDeptBusinessContentListByBusinessPlanId(businessPlanId, deptId);
	}

	@Override
	public boolean importPlanDataList(List<EvaluationDeptBusinessContent> evaluationDeptBusinessContentList) {
		boolean b = false;
		for (EvaluationDeptBusinessContent evaluationDeptBusinessContent : evaluationDeptBusinessContentList) {
			QueryWrapper<EvaluationDeptBusinessContent> qw = new QueryWrapper<>();
			if (StringUtils.isNotEmpty(evaluationDeptBusinessContent.getBusinessPlanId())) {
				qw.lambda().like(EvaluationDeptBusinessContent::getBusinessPlanId, evaluationDeptBusinessContent.getBusinessPlanId());
			}
			if (StringUtils.isNotEmpty(evaluationDeptBusinessContent.getTargetName())) {
				qw.lambda().like(EvaluationDeptBusinessContent::getTargetName, evaluationDeptBusinessContent.getTargetName());
			}
			List<EvaluationDeptBusinessContent> objList = super.list(qw);
			if (objList.size() == 1) {//修改
				evaluationDeptBusinessContent.setId(objList.get(0).getId());
				evaluationDeptBusinessContent.setUpdateTime(DateUtil.date());
				b = super.updateById(evaluationDeptBusinessContent);
			} else if (objList.size() == 0) {//新增
				List<OrganizationStructure> organizationStructureList = organizationStructureService.getTree("23031001", 1, "140");
				OrganizationStructure organizationStructure = organizationStructureList.get(0).getChildren().stream().filter(item -> item.getId().equals(evaluationDeptBusinessContent.getDeptId())).findFirst().orElse(null);
				if (null != organizationStructure) {
					evaluationDeptBusinessContent.setAuditStatus("-1");
					evaluationDeptBusinessContent.setAuditStatusKp("-1");
					evaluationDeptBusinessContent.setDeptName(organizationStructure.getName());
					evaluationDeptBusinessContent.setCreateTime(DateUtil.date());
					b = super.save(evaluationDeptBusinessContent);
				}
			}
		}
		return b;
	}

	@Override
	public boolean importAssessmentDataList(List<EvaluationDeptBusinessContent> evaluationDeptBusinessContentList) {
		boolean b = false;
		for (EvaluationDeptBusinessContent evaluationDeptBusinessContent : evaluationDeptBusinessContentList) {
			QueryWrapper<EvaluationDeptBusinessContent> qw = new QueryWrapper<>();
			if (StringUtils.isNotEmpty(evaluationDeptBusinessContent.getBusinessPlanId())) {
				qw.lambda().like(EvaluationDeptBusinessContent::getBusinessPlanId, evaluationDeptBusinessContent.getBusinessPlanId());
			}
			if (StringUtils.isNotEmpty(evaluationDeptBusinessContent.getTargetName())) {
				qw.lambda().like(EvaluationDeptBusinessContent::getTargetName, evaluationDeptBusinessContent.getTargetName());
			}
			List<EvaluationDeptBusinessContent> objList = super.list(qw);
			if (objList.size() == 1) {//修改
				evaluationDeptBusinessContent.setId(objList.get(0).getId());
				evaluationDeptBusinessContent.setUpdateTime(DateUtil.date());
				b = super.updateById(evaluationDeptBusinessContent);
			}
		}
		return b;
	}
}
